]> asedeno.scripts.mit.edu Git - git.git/blob - t/test-lib.sh
Support showing notes from more than one notes tree
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10         # do not redirect again
11         ;;
12 *' --tee '*|*' --va'*)
13         mkdir -p test-results
14         BASE=test-results/$(basename "$0" .sh)
15         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16          echo $? > $BASE.exit) | tee $BASE.out
17         test "$(cat $BASE.exit)" = 0
18         exit
19         ;;
20 esac
21
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
24
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 unset VISUAL
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 unset GIT_NOTES_REF
58 unset GIT_NOTES_DISPLAY_REF
59 GIT_MERGE_VERBOSITY=5
60 export GIT_MERGE_VERBOSITY
61 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
62 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
63 export EDITOR
64 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
65
66 # Protect ourselves from common misconfiguration to export
67 # CDPATH into the environment
68 unset CDPATH
69
70 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
71         1|2|true)
72                 echo "* warning: Some tests will not work if GIT_TRACE" \
73                         "is set as to trace on STDERR ! *"
74                 echo "* warning: Please set GIT_TRACE to something" \
75                         "other than 1, 2 or true ! *"
76                 ;;
77 esac
78
79 # Each test should start with something like this, after copyright notices:
80 #
81 # test_description='Description of this test...
82 # This test checks if command xyzzy does the right thing...
83 # '
84 # . ./test-lib.sh
85 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
86                 TERM=$ORIGINAL_TERM &&
87                 export TERM &&
88                 [ -t 1 ] &&
89                 tput bold >/dev/null 2>&1 &&
90                 tput setaf 1 >/dev/null 2>&1 &&
91                 tput sgr0 >/dev/null 2>&1
92         ) &&
93         color=t
94
95 while test "$#" -ne 0
96 do
97         case "$1" in
98         -d|--d|--de|--deb|--debu|--debug)
99                 debug=t; shift ;;
100         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
101                 immediate=t; shift ;;
102         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
103                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
104         -h|--h|--he|--hel|--help)
105                 help=t; shift ;;
106         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
107                 verbose=t; shift ;;
108         -q|--q|--qu|--qui|--quie|--quiet)
109                 quiet=t; shift ;;
110         --with-dashes)
111                 with_dashes=t; shift ;;
112         --no-color)
113                 color=; shift ;;
114         --no-python)
115                 # noop now...
116                 shift ;;
117         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
118                 valgrind=t; verbose=t; shift ;;
119         --tee)
120                 shift ;; # was handled already
121         --root=*)
122                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
123                 shift ;;
124         *)
125                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
126         esac
127 done
128
129 if test -n "$color"; then
130         say_color () {
131                 (
132                 TERM=$ORIGINAL_TERM
133                 export TERM
134                 case "$1" in
135                         error) tput bold; tput setaf 1;; # bold red
136                         skip)  tput bold; tput setaf 2;; # bold green
137                         pass)  tput setaf 2;;            # green
138                         info)  tput setaf 3;;            # brown
139                         *) test -n "$quiet" && return;;
140                 esac
141                 shift
142                 printf "* %s" "$*"
143                 tput sgr0
144                 echo
145                 )
146         }
147 else
148         say_color() {
149                 test -z "$1" && test -n "$quiet" && return
150                 shift
151                 echo "* $*"
152         }
153 fi
154
155 error () {
156         say_color error "error: $*"
157         GIT_EXIT_OK=t
158         exit 1
159 }
160
161 say () {
162         say_color info "$*"
163 }
164
165 test "${test_description}" != "" ||
166 error "Test script did not set test_description."
167
168 if test "$help" = "t"
169 then
170         echo "$test_description"
171         exit 0
172 fi
173
174 exec 5>&1
175 if test "$verbose" = "t"
176 then
177         exec 4>&2 3>&1
178 else
179         exec 4>/dev/null 3>/dev/null
180 fi
181
182 test_failure=0
183 test_count=0
184 test_fixed=0
185 test_broken=0
186 test_success=0
187
188 die () {
189         code=$?
190         if test -n "$GIT_EXIT_OK"
191         then
192                 exit $code
193         else
194                 echo >&5 "FATAL: Unexpected exit with code $code"
195                 exit 1
196         fi
197 }
198
199 GIT_EXIT_OK=
200 trap 'die' EXIT
201
202 # The semantics of the editor variables are that of invoking
203 # sh -c "$EDITOR \"$@\"" files ...
204 #
205 # If our trash directory contains shell metacharacters, they will be
206 # interpreted if we just set $EDITOR directly, so do a little dance with
207 # environment variables to work around this.
208 #
209 # In particular, quoting isn't enough, as the path may contain the same quote
210 # that we're using.
211 test_set_editor () {
212         FAKE_EDITOR="$1"
213         export FAKE_EDITOR
214         EDITOR='"$FAKE_EDITOR"'
215         export EDITOR
216 }
217
218 test_decode_color () {
219         sed     -e 's/.\[1m/<WHITE>/g' \
220                 -e 's/.\[31m/<RED>/g' \
221                 -e 's/.\[32m/<GREEN>/g' \
222                 -e 's/.\[33m/<YELLOW>/g' \
223                 -e 's/.\[34m/<BLUE>/g' \
224                 -e 's/.\[35m/<MAGENTA>/g' \
225                 -e 's/.\[36m/<CYAN>/g' \
226                 -e 's/.\[m/<RESET>/g'
227 }
228
229 test_tick () {
230         if test -z "${test_tick+set}"
231         then
232                 test_tick=1112911993
233         else
234                 test_tick=$(($test_tick + 60))
235         fi
236         GIT_COMMITTER_DATE="$test_tick -0700"
237         GIT_AUTHOR_DATE="$test_tick -0700"
238         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
239 }
240
241 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
242 #
243 # This will commit a file with the given contents and the given commit
244 # message.  It will also add a tag with <message> as name.
245 #
246 # Both <file> and <contents> default to <message>.
247
248 test_commit () {
249         file=${2:-"$1.t"}
250         echo "${3-$1}" > "$file" &&
251         git add "$file" &&
252         test_tick &&
253         git commit -m "$1" &&
254         git tag "$1"
255 }
256
257 # Call test_merge with the arguments "<message> <commit>", where <commit>
258 # can be a tag pointing to the commit-to-merge.
259
260 test_merge () {
261         test_tick &&
262         git merge -m "$1" "$2" &&
263         git tag "$1"
264 }
265
266 # This function helps systems where core.filemode=false is set.
267 # Use it instead of plain 'chmod +x' to set or unset the executable bit
268 # of a file in the working directory and add it to the index.
269
270 test_chmod () {
271         chmod "$@" &&
272         git update-index --add "--chmod=$@"
273 }
274
275 # Use test_set_prereq to tell that a particular prerequisite is available.
276 # The prerequisite can later be checked for in two ways:
277 #
278 # - Explicitly using test_have_prereq.
279 #
280 # - Implicitly by specifying the prerequisite tag in the calls to
281 #   test_expect_{success,failure,code}.
282 #
283 # The single parameter is the prerequisite tag (a simple word, in all
284 # capital letters by convention).
285
286 test_set_prereq () {
287         satisfied="$satisfied$1 "
288 }
289 satisfied=" "
290
291 test_have_prereq () {
292         case $satisfied in
293         *" $1 "*)
294                 : yes, have it ;;
295         *)
296                 ! : nope ;;
297         esac
298 }
299
300 # You are not expected to call test_ok_ and test_failure_ directly, use
301 # the text_expect_* functions instead.
302
303 test_ok_ () {
304         test_success=$(($test_success + 1))
305         say_color "" "  ok $test_count: $@"
306 }
307
308 test_failure_ () {
309         test_failure=$(($test_failure + 1))
310         say_color error "FAIL $test_count: $1"
311         shift
312         echo "$@" | sed -e 's/^/        /'
313         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
314 }
315
316 test_known_broken_ok_ () {
317         test_fixed=$(($test_fixed+1))
318         say_color "" "  FIXED $test_count: $@"
319 }
320
321 test_known_broken_failure_ () {
322         test_broken=$(($test_broken+1))
323         say_color skip "  still broken $test_count: $@"
324 }
325
326 test_debug () {
327         test "$debug" = "" || eval "$1"
328 }
329
330 test_run_ () {
331         eval >&3 2>&4 "$1"
332         eval_ret="$?"
333         return 0
334 }
335
336 test_skip () {
337         test_count=$(($test_count+1))
338         to_skip=
339         for skp in $GIT_SKIP_TESTS
340         do
341                 case $this_test.$test_count in
342                 $skp)
343                         to_skip=t
344                 esac
345         done
346         if test -z "$to_skip" && test -n "$prereq" &&
347            ! test_have_prereq "$prereq"
348         then
349                 to_skip=t
350         fi
351         case "$to_skip" in
352         t)
353                 say_color skip >&3 "skipping test: $@"
354                 say_color skip "skip $test_count: $1"
355                 : true
356                 ;;
357         *)
358                 false
359                 ;;
360         esac
361 }
362
363 test_expect_failure () {
364         test "$#" = 3 && { prereq=$1; shift; } || prereq=
365         test "$#" = 2 ||
366         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
367         if ! test_skip "$@"
368         then
369                 say >&3 "checking known breakage: $2"
370                 test_run_ "$2"
371                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
372                 then
373                         test_known_broken_ok_ "$1"
374                 else
375                         test_known_broken_failure_ "$1"
376                 fi
377         fi
378         echo >&3 ""
379 }
380
381 test_expect_success () {
382         test "$#" = 3 && { prereq=$1; shift; } || prereq=
383         test "$#" = 2 ||
384         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
385         if ! test_skip "$@"
386         then
387                 say >&3 "expecting success: $2"
388                 test_run_ "$2"
389                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
390                 then
391                         test_ok_ "$1"
392                 else
393                         test_failure_ "$@"
394                 fi
395         fi
396         echo >&3 ""
397 }
398
399 test_expect_code () {
400         test "$#" = 4 && { prereq=$1; shift; } || prereq=
401         test "$#" = 3 ||
402         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
403         if ! test_skip "$@"
404         then
405                 say >&3 "expecting exit code $1: $3"
406                 test_run_ "$3"
407                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
408                 then
409                         test_ok_ "$2"
410                 else
411                         test_failure_ "$@"
412                 fi
413         fi
414         echo >&3 ""
415 }
416
417 # test_external runs external test scripts that provide continuous
418 # test output about their progress, and succeeds/fails on
419 # zero/non-zero exit code.  It outputs the test output on stdout even
420 # in non-verbose mode, and announces the external script with "* run
421 # <n>: ..." before running it.  When providing relative paths, keep in
422 # mind that all scripts run in "trash directory".
423 # Usage: test_external description command arguments...
424 # Example: test_external 'Perl API' perl ../path/to/test.pl
425 test_external () {
426         test "$#" = 4 && { prereq=$1; shift; } || prereq=
427         test "$#" = 3 ||
428         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
429         descr="$1"
430         shift
431         if ! test_skip "$descr" "$@"
432         then
433                 # Announce the script to reduce confusion about the
434                 # test output that follows.
435                 say_color "" " run $test_count: $descr ($*)"
436                 # Run command; redirect its stderr to &4 as in
437                 # test_run_, but keep its stdout on our stdout even in
438                 # non-verbose mode.
439                 "$@" 2>&4
440                 if [ "$?" = 0 ]
441                 then
442                         test_ok_ "$descr"
443                 else
444                         test_failure_ "$descr" "$@"
445                 fi
446         fi
447 }
448
449 # Like test_external, but in addition tests that the command generated
450 # no output on stderr.
451 test_external_without_stderr () {
452         # The temporary file has no (and must have no) security
453         # implications.
454         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
455         stderr="$tmp/git-external-stderr.$$.tmp"
456         test_external "$@" 4> "$stderr"
457         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
458         descr="no stderr: $1"
459         shift
460         say >&3 "expecting no stderr from previous command"
461         if [ ! -s "$stderr" ]; then
462                 rm "$stderr"
463                 test_ok_ "$descr"
464         else
465                 if [ "$verbose" = t ]; then
466                         output=`echo; echo Stderr is:; cat "$stderr"`
467                 else
468                         output=
469                 fi
470                 # rm first in case test_failure exits.
471                 rm "$stderr"
472                 test_failure_ "$descr" "$@" "$output"
473         fi
474 }
475
476 # This is not among top-level (test_expect_success | test_expect_failure)
477 # but is a prefix that can be used in the test script, like:
478 #
479 #       test_expect_success 'complain and die' '
480 #           do something &&
481 #           do something else &&
482 #           test_must_fail git checkout ../outerspace
483 #       '
484 #
485 # Writing this as "! git checkout ../outerspace" is wrong, because
486 # the failure could be due to a segv.  We want a controlled failure.
487
488 test_must_fail () {
489         "$@"
490         test $? -gt 0 -a $? -le 129 -o $? -gt 192
491 }
492
493 # test_cmp is a helper function to compare actual and expected output.
494 # You can use it like:
495 #
496 #       test_expect_success 'foo works' '
497 #               echo expected >expected &&
498 #               foo >actual &&
499 #               test_cmp expected actual
500 #       '
501 #
502 # This could be written as either "cmp" or "diff -u", but:
503 # - cmp's output is not nearly as easy to read as diff -u
504 # - not all diff versions understand "-u"
505
506 test_cmp() {
507         $GIT_TEST_CMP "$@"
508 }
509
510 # Most tests can use the created repository, but some may need to create more.
511 # Usage: test_create_repo <directory>
512 test_create_repo () {
513         test "$#" = 1 ||
514         error "bug in the test script: not 1 parameter to test-create-repo"
515         owd=`pwd`
516         repo="$1"
517         mkdir -p "$repo"
518         cd "$repo" || error "Cannot setup test environment"
519         "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
520         error "cannot run git init -- have you built things yet?"
521         mv .git/hooks .git/hooks-disabled
522         cd "$owd"
523 }
524
525 test_done () {
526         GIT_EXIT_OK=t
527         test_results_dir="$TEST_DIRECTORY/test-results"
528         mkdir -p "$test_results_dir"
529         test_results_path="$test_results_dir/${0%.sh}-$$"
530
531         echo "total $test_count" >> $test_results_path
532         echo "success $test_success" >> $test_results_path
533         echo "fixed $test_fixed" >> $test_results_path
534         echo "broken $test_broken" >> $test_results_path
535         echo "failed $test_failure" >> $test_results_path
536         echo "" >> $test_results_path
537
538         if test "$test_fixed" != 0
539         then
540                 say_color pass "fixed $test_fixed known breakage(s)"
541         fi
542         if test "$test_broken" != 0
543         then
544                 say_color error "still have $test_broken known breakage(s)"
545                 msg="remaining $(($test_count-$test_broken)) test(s)"
546         else
547                 msg="$test_count test(s)"
548         fi
549         case "$test_failure" in
550         0)
551                 say_color pass "passed all $msg"
552
553                 test -d "$remove_trash" &&
554                 cd "$(dirname "$remove_trash")" &&
555                 rm -rf "$(basename "$remove_trash")"
556
557                 exit 0 ;;
558
559         *)
560                 say_color error "failed $test_failure among $msg"
561                 exit 1 ;;
562
563         esac
564 }
565
566 # Test the binaries we have just built.  The tests are kept in
567 # t/ subdirectory and are run in 'trash directory' subdirectory.
568 TEST_DIRECTORY=$(pwd)
569 if test -n "$valgrind"
570 then
571         make_symlink () {
572                 test -h "$2" &&
573                 test "$1" = "$(readlink "$2")" || {
574                         # be super paranoid
575                         if mkdir "$2".lock
576                         then
577                                 rm -f "$2" &&
578                                 ln -s "$1" "$2" &&
579                                 rm -r "$2".lock
580                         else
581                                 while test -d "$2".lock
582                                 do
583                                         say "Waiting for lock on $2."
584                                         sleep 1
585                                 done
586                         fi
587                 }
588         }
589
590         make_valgrind_symlink () {
591                 # handle only executables
592                 test -x "$1" || return
593
594                 base=$(basename "$1")
595                 symlink_target=$TEST_DIRECTORY/../$base
596                 # do not override scripts
597                 if test -x "$symlink_target" &&
598                     test ! -d "$symlink_target" &&
599                     test "#!" != "$(head -c 2 < "$symlink_target")"
600                 then
601                         symlink_target=../valgrind.sh
602                 fi
603                 case "$base" in
604                 *.sh|*.perl)
605                         symlink_target=../unprocessed-script
606                 esac
607                 # create the link, or replace it if it is out of date
608                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
609         }
610
611         # override all git executables in TEST_DIRECTORY/..
612         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
613         mkdir -p "$GIT_VALGRIND"/bin
614         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
615         do
616                 make_valgrind_symlink $file
617         done
618         OLDIFS=$IFS
619         IFS=:
620         for path in $PATH
621         do
622                 ls "$path"/git-* 2> /dev/null |
623                 while read file
624                 do
625                         make_valgrind_symlink "$file"
626                 done
627         done
628         IFS=$OLDIFS
629         PATH=$GIT_VALGRIND/bin:$PATH
630         GIT_EXEC_PATH=$GIT_VALGRIND/bin
631         export GIT_VALGRIND
632 elif test -n "$GIT_TEST_INSTALLED" ; then
633         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
634         error "Cannot run git from $GIT_TEST_INSTALLED."
635         PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
636         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
637 else # normal case, use ../bin-wrappers only unless $with_dashes:
638         git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
639         if ! test -x "$git_bin_dir/git" ; then
640                 if test -z "$with_dashes" ; then
641                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
642                 fi
643                 with_dashes=t
644         fi
645         PATH="$git_bin_dir:$PATH"
646         GIT_EXEC_PATH=$TEST_DIRECTORY/..
647         if test -n "$with_dashes" ; then
648                 PATH="$TEST_DIRECTORY/..:$PATH"
649         fi
650 fi
651 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
652 unset GIT_CONFIG
653 GIT_CONFIG_NOSYSTEM=1
654 GIT_CONFIG_NOGLOBAL=1
655 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
656
657 . ../GIT-BUILD-OPTIONS
658
659 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
660 export GITPERLLIB
661 test -d ../templates/blt || {
662         error "You haven't built things yet, have you?"
663 }
664
665 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
666 then
667         GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
668         export GITPYTHONLIB
669         test -d ../git_remote_helpers/build || {
670                 error "You haven't built git_remote_helpers yet, have you?"
671         }
672 fi
673
674 if ! test -x ../test-chmtime; then
675         echo >&2 'You need to build test-chmtime:'
676         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
677         exit 1
678 fi
679
680 # Test repository
681 test="trash directory.$(basename "$0" .sh)"
682 test -n "$root" && test="$root/$test"
683 case "$test" in
684 /*) TRASH_DIRECTORY="$test" ;;
685  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
686 esac
687 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
688 rm -fr "$test" || {
689         GIT_EXIT_OK=t
690         echo >&5 "FATAL: Cannot prepare test area"
691         exit 1
692 }
693
694 test_create_repo "$test"
695 # Use -P to resolve symlinks in our working directory so that the cwd
696 # in subprocesses like git equals our $PWD (for pathname comparisons).
697 cd -P "$test" || exit 1
698
699 this_test=${0##*/}
700 this_test=${this_test%%-*}
701 for skp in $GIT_SKIP_TESTS
702 do
703         to_skip=
704         for skp in $GIT_SKIP_TESTS
705         do
706                 case "$this_test" in
707                 $skp)
708                         to_skip=t
709                 esac
710         done
711         case "$to_skip" in
712         t)
713                 say_color skip >&3 "skipping test $this_test altogether"
714                 say_color skip "skip all tests in $this_test"
715                 test_done
716         esac
717 done
718
719 # Provide an implementation of the 'yes' utility
720 yes () {
721         if test $# = 0
722         then
723                 y=y
724         else
725                 y="$*"
726         fi
727
728         while echo "$y"
729         do
730                 :
731         done
732 }
733
734 # Fix some commands on Windows
735 case $(uname -s) in
736 *MINGW*)
737         # Windows has its own (incompatible) sort and find
738         sort () {
739                 /usr/bin/sort "$@"
740         }
741         find () {
742                 /usr/bin/find "$@"
743         }
744         sum () {
745                 md5sum "$@"
746         }
747         # git sees Windows-style pwd
748         pwd () {
749                 builtin pwd -W
750         }
751         # no POSIX permissions
752         # backslashes in pathspec are converted to '/'
753         # exec does not inherit the PID
754         ;;
755 *)
756         test_set_prereq POSIXPERM
757         test_set_prereq BSLASHPSPEC
758         test_set_prereq EXECKEEPSPID
759         ;;
760 esac
761
762 test -z "$NO_PERL" && test_set_prereq PERL
763 test -z "$NO_PYTHON" && test_set_prereq PYTHON
764
765 # test whether the filesystem supports symbolic links
766 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
767 rm -f y